package session;
######################################################################

# å饤֥ Ver1.0.2

# Copyright (c) 2003 Toshinori Kondo <kondo@bsp-net.com>
# $Id: session.pl,v 1.4 2003/07/05 16:16:51 toshi Exp $

######################################################################

# 
#  Ver1.0.0 2003/07/01 ⥸塼뤬ѤǤʤĶΰ٤ˡ
#  Ver1.0.1 2003/07/04 ڤƤΥåؿɲá
#  Ver1.0.2 2003/07/06 limit,clearؿΥХ

# åΥǡǥ쥯ȥϡ
# ͽᡢĶѿSessionTempDirפ˳ǼƻѤ

# åͭ¤ϡ
# ߤλ֤鲿̤ޤͭÿ
# ͽᡢĶѿSessionLimitפ˳ǼƻѤ

# newؿ
#   åIDκȡǡեޤ
#   session::new();
#   ˤϡåID֤ޤ
#   Իˤϡundef֤ޤ

# getؿ
#   å󤫤Фޤ
#   session::get($SessionID, \%SessionData);
#   ˤϡ1֤ޤ
#   Իˤϡundef֤ޤ

# setؿ
#   å˾ɲùޤ
#   session::set($SessionID, \%SessionData);
#   ˤϡ1֤ޤ
#   Իˤϡundef֤ޤ

# delayؿ
#   åͭ¤Ĺޤ
#   session::delay($SessionID);
#   ˤϡ1֤ޤ
#   Իˤϡundef֤ޤ

# deleteؿ
#   å˴Ϣդ줿ǡޤ
#   session::delete($SessionID);
#   ˤϡ1֤ޤ
#   Իˤϡundef֤ޤ

# clearؿ
#   ͭڤΥåƺޤ
#   session::clear();
#   ƤΥåФơlimitؿƤӽФޤ
#   ˤϡ1֤ޤ
#   Իˤϡundef֤ޤ

# generateؿ
#   $ResultValue = session::generate();
#   3216ʿͤޤ
#   newؿưǸƤӽФΤǡä˻Ѥɬפ̵

# limitؿ
#   åͭ¤ǧڤʤ롣
#   session::limit($SessionID);
#   get,set,delayؿǸƤӽФޤΤǡ
#   Ū˳ǧɬפ̵¤ꡢä˻Ѥɬפ̵
#   ˤϡ1֤ޤ
#   Իˤϡundef֤ޤ

######################################################################

sub new {
	my ($SessionID, $SessionFile, $SessionLimit);
	if (-e $ENV{'SessionTempDir'}) {
		$SessionID = &generate();
		$SessionFile = $ENV{'SessionTempDir'} . '/' . $SessionID;
		if ($ENV{'SessionLimit'}) {
			$SessionLimit = time() + $ENV{'SessionLimit'};
			if (!(-e $SessionFile)) {
				open SSID, "> $SessionFile";
				print SSID 'LIMITTIME=' . $SessionLimit . "\n";
				close SSID;
				if (-e $SessionFile) {
					chmod 0666, $SessionFile;
					return $SessionID;
				}
			}
		}
	}
	return undef;
}

sub get {
	my ($SessionID, $ref_session) = @_;
	my ($SessionFile, $temp, $SessionName, $SessionValue, $key);
	$SessionFile = $ENV{'SessionTempDir'} . '/' . $SessionID;
	%$ref_session = ();
	&limit($SessionID);
	if (-e $SessionFile) {
		open SSID, $SessionFile;
		flock(SSID, 2);
		$temp = <SSID>;
		while (<SSID>) {
			$_ =~ s/\x0D?\x0A?$//;
			($SessionName, $SessionValue) = split(/=/, $_, 2);
			$ref_session->{$SessionName} = $SessionValue;
		}
		close SSID;
		$ref_session->{'SESSIONID'} = $SessionID;
		return 1;
	}
	return undef;
}

sub set {
	my ($SessionID, $ref_session) = @_;
	my (%TempSession, $SessionFile, $SessionLimit, $key);
	&limit($SessionID);
	$SessionFile = $ENV{'SessionTempDir'} . '/' . $SessionID;
	if (-e $SessionFile) {
		open SSID, "+< $SessionFile";
		flock(SSID, 2);
		truncate(SSID, 0);
		seek(SSID, 0, 0);
		if ($ENV{'SessionLimit'} eq '') {
			$SessionLimit = $TempSession{'LIMITTIME'};
		}
		else {
			$SessionLimit = time() + $ENV{'SessionLimit'};
		}
		print SSID 'LIMITTIME=' . $SessionLimit . "\n";
		foreach $key (sort keys %$ref_session) {
			if ($key ne 'SESSIONID' and $key ne 'LIMITTIME') {
				if ($ref_session->{$key} ne '') {
					print SSID $key . '=' . $ref_session->{$key} . "\n";
				}
			}
		}
		close SSID;
		return 1;
	}
	return undef;
}

sub delay {
	my ($SessionID) = @_;
	my (%TempSession, $SessionFile, $SessionLimit, $temp);
	if ($ENV{'SessionLimit'}) {
		&limit($SessionID);
		$SessionFile = $ENV{'SessionTempDir'} . '/' . $SessionID;
		if (-e $SessionFile) {
			open SSID, "+< $SessionFile";
			flock(SSID, 2);
			$SessionLimit = <SSID>;
			$temp = '';
			while (<SSID>) {
				$temp .= $_;
			}
			truncate(SSID, 0);
			seek(SSID, 0, 0);
			$SessionLimit = time() + $ENV{'SessionLimit'};
			print SSID 'LIMITTIME=' . $SessionLimit . "\n";
			print SSID $temp;
			close SSID;
			return 1;
		}
	}
	return undef;
}

sub delete {
	my ($SessionID) = @_;
	my ($SessionFile);
	$SessionFile = $ENV{'SessionTempDir'} . '/' . $SessionID;
	if (-e $SessionFile) {
		unlink $SessionFile;
		if (-e $SessionFile) {
			return undef;
		}
	}
	return 1;
}

sub clear {
	my (@SessionID, $i, $ret, $flag);
	if (-e $ENV{'SessionTempDir'}) {
		opendir DIR, $ENV{'SessionTempDir'};
		@SessionID = grep(!/^\./, readdir(DIR));
		closedir DIR;
		$flag = 0;
		for ($i = 0; $i <= $#SessionID; $i++) {
			$ret = &limit($SessionID[$i]);
			if (defined $ret) {
				$flag++;
			}
		}
		if (!($temp > 0)) {
			return 1;
		}
	}
	return undef;
}

sub generate {
	my $result = '';
	for ($i = 0; $i < 32; $i++) {
		$result .= sprintf("%x", int(rand(16)));
	}
	return $result
}

sub limit {
	my ($SessionID) = @_;
	my ($SessionFile, $SessionLimit);
	$SessionFile = $ENV{'SessionTempDir'} . '/' . $SessionID;
	if (-e $SessionFile) {
		open SSID, $SessionFile;
		flock(SSID, 2);
		$SessionLimit = <SSID>;
		$SessionLimit =~ s/\x0D?\x0A?$//;
		$SessionLimit = (split(/=/, $SessionLimit, 2))[1];
		close SSID;
		if ($SessionLimit < time()) {
			$ret = &delete($SessionID);
			if ($ret) {
				return 1;
			}
			return undef;
		}
		return 1;
	}
	return undef;
}

1;
